package controller

import (
	"fmt"
	"time"

	"be.ems/src/framework/i18n"
	"be.ems/src/framework/reqctx"
	"be.ems/src/framework/resp"
	"be.ems/src/framework/utils/parse"
	neFetchlink "be.ems/src/modules/ne/fetch_link"
	neService "be.ems/src/modules/ne/service"
	neDataService "be.ems/src/modules/ne_data/service"

	"github.com/gin-gonic/gin"
)

// 实例化控制层 MMEController 结构体
var NewMME = &MMEController{
	neInfoService:  neService.NewNeInfo,
	ueEventService: neDataService.NewUEEvent,
}

// 网元MME
//
// PATH /mme
type MMEController struct {
	neInfoService  *neService.NeInfo      // 网元信息服务
	ueEventService *neDataService.UEEvent // UE会话事件服务
}

// UE会话列表
//
// GET /ue/list
//
//	@Tags			ne_data/mme
//	@Accept			json
//	@Produce		json
//	@Param			neType		query		string	true	"NE Type only MME"	Enums(MME)
//	@Param			neId		query		string	true	"NE ID"				default(001)
//	@Param			imsi		query		string	false	"imsi"
//	@Param			pageNum		query		number	true	"pageNum"	default(1)
//	@Param			pageSize	query		number	true	"pageSize"	default(10)
//	@Success		200			{object}	object	"Response Results"
//	@Security		TokenAuth
//	@Summary		UE Session List
//	@Description	UE Session List
//	@Router			/neData/mme/ue/list [get]
func (s *MMEController) UEList(c *gin.Context) {
	language := reqctx.AcceptLanguage(c)
	query := reqctx.QueryMap(c)
	// 分页检查
	pageNum := parse.Number(query["pageNum"])
	pageSize := parse.Number(query["pageSize"])
	if pageNum == 0 || pageSize == 0 {
		c.JSON(422, resp.CodeMsg(resp.CODE_PARAM_CHEACK, "bind err: pageNum or pageSize not is empty"))
		return
	}
	// 查询网元信息 rmUID
	neInfo := s.neInfoService.FindByNeTypeAndNeID(query["neType"], query["neId"])
	if neInfo.NeType == "" {
		c.JSON(200, resp.ErrMsg(i18n.TKey(language, "app.common.noNEInfo")))
		return
	}
	query["rmUID"] = neInfo.RmUID
	rows, total := s.ueEventService.FindByPage(neInfo.NeType, query)
	c.JSON(200, resp.OkData(map[string]any{"rows": rows, "total": total}))
}

// UE会话删除
//
// DELETE /ue/:id
//
//	@Tags			ne_data/mme
//	@Accept			json
//	@Produce		json
//	@Param			id	path		string	true	"list data id, multiple separated by a , sign"
//	@Success		200	{object}	object	"Response Results"
//	@Security		TokenAuth
//	@Summary		UE Session Deletion
//	@Description	UE Session Deletion
//	@Router			/neData/mme/ue/{id} [delete]
func (s *MMEController) UERemove(c *gin.Context) {
	language := reqctx.AcceptLanguage(c)
	id := c.Param("id")
	if id == "" {
		c.JSON(422, resp.CodeMsg(resp.CODE_PARAM_CHEACK, "bind err: id is empty"))
		return
	}

	// 处理字符转id数组后去重
	uniqueIDs := parse.RemoveDuplicatesToArray(id, ",")
	// 转换成int64数组类型
	ids := make([]int64, 0)
	for _, v := range uniqueIDs {
		ids = append(ids, parse.Number(v))
	}

	rows, err := s.ueEventService.DeleteByIds("MME", ids)
	if err != nil {
		c.JSON(200, resp.ErrMsg(i18n.TKey(language, err.Error())))
		return
	}
	msg := i18n.TTemplate(language, "app.common.deleteSuccess", map[string]any{"num": rows})
	c.JSON(200, resp.OkMsg(msg))
}

// UE会话列表导出
//
// GET /ue/export
//
//	@Tags			ne_data/mme
//	@Accept			json
//	@Produce		json
//	@Param			data	body		object	true	"Request Param"
//	@Success		200		{object}	object	"Response Results"
//	@Security		TokenAuth
//	@Summary		UE Session List Export
//	@Description	UE Session List Export
//	@Router			/neData/mme/ue/export [get]
func (s *MMEController) UEExport(c *gin.Context) {
	language := reqctx.AcceptLanguage(c)
	query := reqctx.QueryMap(c)
	// 分页检查
	pageNum := parse.Number(query["pageNum"])
	pageSize := parse.Number(query["pageSize"])
	if pageNum == 0 || pageSize == 0 {
		c.JSON(422, resp.CodeMsg(resp.CODE_PARAM_CHEACK, "bind err: pageNum or pageSize not is empty"))
		return
	}
	// 查询网元信息 rmUID
	neInfo := s.neInfoService.FindByNeTypeAndNeID(query["neType"], query["neId"])
	if neInfo.NeType == "" {
		c.JSON(200, resp.ErrMsg(i18n.TKey(language, "app.common.noNEInfo")))
		return
	}
	query["rmUID"] = neInfo.RmUID
	rows, total := s.ueEventService.FindByPage(neInfo.NeType, query)
	if total == 0 {
		// 导出数据记录为空
		c.JSON(200, resp.ErrMsg(i18n.TKey(language, "app.common.exportEmpty")))
		return
	}

	// 导出文件名称
	fileName := fmt.Sprintf("mme_ue_event_export_%d_%d.xlsx", len(rows), time.Now().UnixMilli())
	// 导出数据表格
	saveFilePath, err := s.ueEventService.ExportMME(rows, fileName, language)
	if err != nil {
		c.JSON(200, resp.ErrMsg(err.Error()))
		return
	}

	c.FileAttachment(saveFilePath, fileName)
}

// 接入基站信息列表
//
// GET /nb/list
//
//	@Tags			ne_data/mme
//	@Accept			json
//	@Produce		json
//	@Param			neId	query		string	true	"NE ID"	default(001)
//	@Param			id		query		string	false	"Base Station ID"
//	@Success		200		{object}	object	"Response Results"
//	@Security		TokenAuth
//	@Summary		Access Base Station Information List
//	@Description	Access Base Station Information List
//	@Router			/neData/mme/nb/list [get]
func (s *MMEController) NbInfoList(c *gin.Context) {
	language := reqctx.AcceptLanguage(c)
	var query struct {
		NeId string `form:"neId" binding:"required"`
		NbId string `form:"id"`
	}
	if err := c.ShouldBindQuery(&query); err != nil {
		errMsgs := fmt.Sprintf("bind err: %s", resp.FormatBindError(err))
		c.JSON(422, resp.CodeMsg(resp.CODE_PARAM_PARSER, errMsgs))
		return
	}

	// 查询网元信息
	neInfo := s.neInfoService.FindByNeTypeAndNeID("MME", query.NeId)
	if neInfo.NeId != query.NeId || neInfo.IP == "" {
		c.JSON(200, resp.ErrMsg(i18n.TKey(language, "app.common.noNEInfo")))
		return
	}

	// 网元直连
	data, err := neFetchlink.MMENbInfoList(neInfo, map[string]string{
		"id": query.NbId,
	})
	if err != nil {
		c.JSON(200, resp.ErrMsg(err.Error()))
		return
	}

	c.JSON(200, resp.OkData(data))
}

// 接入基站状态信息列表
//
// GET /nb/list-cfg
//
//	@Tags			ne_data/mme
//	@Accept			json
//	@Produce		json
//	@Param			neId	query		string	true	"NE ID"	default(001)
//	@Success		200		{object}	object	"Response Results"
//	@Security		TokenAuth
//	@Summary		Access to the base station status information list
//	@Description	Access to the base station status information list
//	@Router			/neData/mme/nb/list-cfg [get]
func (s *MMEController) NbStateList(c *gin.Context) {
	language := reqctx.AcceptLanguage(c)
	neId := c.Query("neId")
	if neId == "" {
		c.JSON(422, resp.CodeMsg(resp.CODE_PARAM_CHEACK, "bind err: neId is empty"))
		return
	}

	// 查询网元信息
	neInfo := s.neInfoService.FindByNeTypeAndNeID("MME", neId)
	if neInfo.NeId != neId || neInfo.IP == "" {
		c.JSON(200, resp.ErrMsg(i18n.TKey(language, "app.common.noNEInfo")))
		return
	}

	// 网元直连
	data, err := neFetchlink.MMEEnbStateList(neInfo)
	if err != nil {
		c.JSON(200, resp.ErrMsg(err.Error()))
		return
	}

	c.JSON(200, resp.OkData(data))
}
